﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Optimization;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HEAL.Attic;

namespace HeuristicLab.Problems.MetaOptimization {
  [StorableType("4A2B5B18-F678-45FE-B59E-06BD79F5982A")]
  public class AlgorithmProblemItem : ParameterizedNamedItem {
    #region Parameter Properties
    public IValueParameter<IAlgorithm> AlgorithmParameter {
      get { return (ValueParameter<IAlgorithm>)Parameters["Algorithm"]; }
    }
    public IValueParameter<IProblem> ProblemParameter {
      get { return (ValueParameter<IProblem>)Parameters["Problem"]; }
    }
    #endregion

    #region Constructors and Cloning
    [StorableConstructor]
    protected AlgorithmProblemItem(StorableConstructorFlag _) : base(_) { }
    public AlgorithmProblemItem() {
      this.Parameters.Add(new ValueParameter<IAlgorithm>("Algorithm"));
      this.Parameters.Add(new ValueParameter<IProblem>("Problem"));
    }
    protected AlgorithmProblemItem(AlgorithmProblemItem original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new AlgorithmProblemItem(this, cloner);
    }
    #endregion
  }
}
